use nanoid::nanoid;
use serde::{Deserialize, Serialize};
use serde_json::Value;
use std::boxed::Box;
use std::collections::HashMap;
use std::error::Error;
use std::marker::PhantomData;
use std::marker::Send;
use std::sync::mpsc::{Receiver, Sender};
use std::sync::{Arc, Mutex};
use threadpool::ThreadPool;

pub type Result<T> = std::result::Result<T, Box<dyn Error>>;

#[derive(Serialize, Deserialize)]
pub struct JRPCRequest {
    pub jsonrpc: String,
    pub id: Option<String>,
    pub method: String,
    pub params: Value,
}

#[derive(Serialize, Deserialize)]
pub struct JRPCError {
    pub code: i64,
    pub message: String,
    pub data: Value,
}

#[derive(Serialize, Deserialize)]
pub struct JRPCResult {
    pub jsonrpc: String,
    pub id: String,
    pub result: Value,
    pub error: Option<JRPCError>,
}

struct JRPCServer {}

impl JRPCServer {
    fn handle(&self) -> () {}
}

struct JRPCServerService {}
